//+------------------------------------------------------------------+
//|                                                  ATR_RATCHET.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
#property indicator_buffers 4
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 Blue
#property indicator_color4 Red

extern int Atr_Length = 1;
extern int LL_Length = 10;
extern int HH_Length = 10;
extern double ratio = 0.05;
extern int startBar = 118;
double pratr[];
double mratr[];

double pratrline[];
double mratrline[];

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexBuffer(0,pratr);
SetIndexStyle(0,DRAW_ARROW);
SetIndexArrow(0,167);

SetIndexBuffer(1,mratr);
SetIndexStyle(1,DRAW_ARROW);
SetIndexArrow(1,167);


SetIndexBuffer(2,pratrline);
SetIndexStyle(2,DRAW_LINE);


SetIndexBuffer(3,mratrline);
SetIndexStyle(3,DRAW_LINE);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit = startBar;
//----
   for(int i=limit;i>=0;i--)
   {
      double LL = Low[Lowest(Symbol(),0,MODE_LOW,LL_Length,i)];
      double HH = High[Highest(Symbol(),0,MODE_HIGH,HH_Length,i)];
      double atr = (iATR(Symbol(),0,Atr_Length,i)/Point);
      pratr[i]=LL+( (atr + (atr*ratio))*Point) ;
      mratr[i]=HH-( (atr + (atr*ratio))*Point) ;
      pratrline[i]=LL+( (atr + (atr*ratio))*Point) ;
      mratrline[i]=HH-( (atr + (atr*ratio))*Point) ;
      
       
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+